import * as PReact from "./preact-shim.ts";
export interface TextLineProps {
    text: string;
    height?: number;
    anchor?: string;
    baseline?: string;
    fontFamily?: string;
    fill?: string;
}
export declare const TextLine: PReact.FunctionComponent<TextLineProps>;
export interface TextProps {
    text: string;
    height?: number;
    fontFamily?: string;
    fill?: string;
    onSizeUpdate?: (size: {
        width: number;
        height: number;
    }) => void;
}
export declare const Text: PReact.FunctionComponent<TextProps>;
export interface TextBoxProps {
    text: string;
    height?: number;
    fontFamily?: string;
    padding?: number;
    fill?: string;
    stroke?: string;
    textFill?: string;
    strokeWidth?: number;
    cornerRadius?: number;
    textOffsetY?: number;
    onSizeUpdate?: (size: {
        width: number;
        height: number;
    }) => void;
}
export declare const TextBox: PReact.FunctionComponent<TextBoxProps>;
export interface LabelledRect extends TextBoxProps {
    width?: number;
    fontSize?: number;
}
export declare const LabelledRect: PReact.FunctionComponent<LabelledRect>;
export interface IconLabelledRect extends LabelledRect {
    icon: string;
    iconFontFamily?: string;
    iconFontSize?: number;
}
export declare const IconLabelledRect: PReact.FunctionComponent<IconLabelledRect>;
